#define F_CPU 12000000UL
#include <avr/io.h>
#include <util/delay.h>     /* for _delay_ms() */

uint16_t read_adc(uint8_t channel){
    ADMUX = 0b01000000; // เลือกใช้แรงดันอ้างอิงจากขา AREF
    ADMUX |= channel;   // ตั้ง MUX ให้ชี้ไปยัง channel
    ADCSRA = 0b11000110;
    //         ||   -+-
    //         ||    |
    //         ||    +-> ปรับคล็อกของ ADC ให้เป็น 1/64 ของคล็อกระบบ
    //         |+->เริ่มแปลงค่าแอนะล็อกเป็นดิจิทัล (บิต ADSC)
    //         |
    //         +-> Enable ADC (บิต ADEN)

    while ((ADCSRA & (1<<ADSC))) // รอจนบิต ADSC (บิต 6) กลายเป็น 0
        ;
    return ADCL + ADCH*256;  // ผลลัพธ์ถูกเก็บอยู่ในรีจีสเตอร์ ADCL และ ADCH
}



main()
{
	
	DDRC =  0b00010100;
	DDRD =  0b11100000;
	uint16_t a,b,c,max,time;
	uint32_t i,j;
	time = 0;
    max = 0;
    _delay_ms(2000);
    //PORTC = 0b00010100;
    /*while(1){
        a = read_adc(3);
        if(a>=300)
            PORTC = 0b00010100;
        else
            PORTC = 0b00000000;
    }*/



	for(i=0;i<120000;i++){
        PORTC = 0b00010000;
        PORTD = 0b00000000;
        b = read_adc(5);
		if(b>max)
			max = b;	
	}

    PORTC = 0b00000000;
    for(i=0;i<4;i++){
	    PORTD = 0b11000000;
    	_delay_ms(100);
    	PORTD = 0b11100000;
    	_delay_ms(400);
    }
    PORTD = 0b01100000;
    
    PORTC = 0b00010000;
	for(i=0;i<120000;i++){
        b = read_adc(5);
		if(b>max-20){
			PORTC = 0b00010100;
            break;
		}
    }

    //_delay_ms(2000);
    //PORTC = 0b00000000;
    //_delay_ms(1000);

	while(1)
	{
		a = read_adc(1);
		b = read_adc(5);
		c = read_adc(3);
		if(time == 1){
		   PORTC = 0b00000000;
			for(j=0;j<10;j++){
				PORTD = 0b11000000;
				_delay_ms(100);
				PORTD = 0b11100000;
				_delay_ms(400);
			}
			time = 0;
		}
		else if( a < 300 && b < 300 && c < 300){
			max = 0;
			for(i=0;i<120000;i++){
				PORTC = 0b00000100;
				if(b > max)
					max = b;
			}

            //PORTC = 0b00000000;
            //_delay_ms(1000);

            if(max < 300){
                time = 1;
                continue;
            }

            PORTC = 0b00000100;
            for(i=0;i<120000;i++){
				if(b>max-20){
					PORTC = 0b00010100;
					break;
				}
			}
		}
		else if(a > b && a>c )
  			PORTC = 0b00010000;
  		else if(b > a && b>c )
  			PORTC = 0b00010100;
  		else if(c > a && c> b)
  			PORTC = 0b00000100;
	}
    //PORTC = 0b00000000;
}

